package oak 

import(
	"strings"
	"bufio"
	"os"
	"log"
	"strconv"
)

func LeClientes(c []Cliente,nome_arq string) []Cliente{
	file, err := os.Open(nome_arq) 
	if err != nil {
		log.Fatal(err)
	}

	defer file.Close()
	scanner := bufio.NewScanner(file)
	line := scanner.Text()	
	i:=0
	for scanner.Scan(){
		line = scanner.Text()
		if i!=0	{
			s:=strings.Split(line, ";")
			if strings.EqualFold(s[5], "J") {
				p := CriaPessoaJuridica(s[1],s[2],s[3],s[4],s[5],s[6],s[0],s[7])
				c = append(c, p)
			}else if strings.EqualFold(s[5], "F") {
				p := CriaPessoaFisica(s[1],s[2],s[3],s[4],s[5],s[6],s[0])
				c = append(c, p)
			}
		}	
		i++	
	}
	return c
}

func LeFornecedores(f []Fornecedor,nome_arq string) []Fornecedor{
	file, err := os.Open(nome_arq) 
	if err != nil {
		log.Fatal(err)
	}

	defer file.Close()
	scanner := bufio.NewScanner(file)
	line := scanner.Text()	
	i:=0
	for scanner.Scan(){
		line = scanner.Text()
		if i!=0 {	
			s:=strings.Split(line, ";")
			fornecedor := CriaFornecedor(s[1], s[2], s[3], s[4], s[5], s[0])
			f = append(f, fornecedor)
		}
		i++
	}
	return f
}

func LeProdutos(prod []Produto,nome_arq string) []Produto{
	file, err := os.Open(nome_arq) 
	if err != nil {
		log.Fatal(err)
	}

	defer file.Close()
	scanner := bufio.NewScanner(file)
	line := scanner.Text()
	i:=0	
	for scanner.Scan(){
		line = scanner.Text()
		if i!=0 {	
			s:=strings.Split(line, ";")
			p := CriaProduto(s[0],s[2],s[3],s[5],s[1],s[4])		
			prod = append(prod, p)
		}
		i++
	}
	return prod
}

func LeCompras(p []Produto, f []Fornecedor, nome_arq string) ([]Produto, []Fornecedor) {
	file, err := os.Open(nome_arq) 
	if err != nil {
		log.Fatal(err)
	}

	defer file.Close()
	scanner := bufio.NewScanner(file)
	line := scanner.Text()	
	i:=0
	for scanner.Scan(){
		line = scanner.Text()
		if i!= 0{	
			s:=strings.Split(line, ";")
			codf,_ := strconv.Atoi(s[1])
			codp,_ := strconv.Atoi(s[3])
			quant,_ := strconv.Atoi(s[4])	
			indexP := BuscaProduto(codp, p)
			indexF := BuscaFornecedor(codf, f)		
			p1 := p[indexP:] 
			p1[0] = Compra(p1[0], quant)
			f1 := f[indexF:] 
			f1[0] = SetTotal(f1[0], p1[0].VCusto*float64(quant))
		}
		i++
	}
	return p, f
}

func LeVendas(p []Produto, c []Cliente, m []Modo, nome_arq string) ([]Produto, []Cliente, []Modo) {
	file, err := os.Open(nome_arq) 
	if err != nil {
		log.Fatal(err)
	}

	defer file.Close()
	
	scanner := bufio.NewScanner(file)
	line := scanner.Text()
	i:=0	
	for scanner.Scan(){
		line = scanner.Text()	
		if i!=0 {
			s:=strings.Split(line, ";")
			quant,_ := strconv.Atoi(s[3])
			codp,_ := strconv.Atoi(s[2])
			pgto := s[4]
			indexP := BuscaProduto(codp, p)
			p1 := p[indexP:]
			valor := ValorVenda(p1[0])
		
			indexM := BuscaModo(pgto, m)
			m1 := m[indexM:]
			m1[0] = ReceitaModo(m1[0], valor*float64(quant))
			m1[0] = LucroModo(m1[0],(valor-p1[0].VCusto)*float64(quant))
		
			if strings.EqualFold(pgto, "F"){
				codc,_ := strconv.Atoi(s[0])
				indexC := BuscaCliente(codc, c)
				c1 := c[indexC:]
				c1[0] = CalcDividaCliente(c1[0], valor*float64(quant))
			}
		}
		i++
	}
	return p, c, m
}
