
package oak

import(
	"strconv"
	"strings"
)

type Produto struct {
	Cod, EstMin, EstAtual, Percentual int
	Descricao string
	Receita, Lucro, VCusto float64
}

func CriaProduto (cod, estMin, estAtual, pLucro, descricao, vCusto string) Produto {
	var p Produto
	p.Cod,_ = strconv.Atoi(cod)
	p.EstMin,_ = strconv.Atoi(estMin)
	p.EstAtual,_ = strconv.Atoi(estAtual)
	p.Percentual,_ = strconv.Atoi(pLucro)
	p.Descricao = descricao
	vCusto = strings.Replace(vCusto,",",".",1)	
	p.VCusto,_ = strconv.ParseFloat(vCusto, 64)		
	p.Receita = 0.0
	p.Lucro = 0.0
	return p
}

func CriaListaProdutos () []Produto {
	p := make([]Produto,0)
	return p
}
	
func Compra (p Produto, quant int) Produto{
	p.EstAtual = p.EstAtual + quant
	return p
}
	
func Venda(p Produto, quant int) Produto {
	p.EstAtual = p.EstAtual - quant
	return p
}

func ReceitaProduto (p Produto, r float64) Produto{
	p.Receita = p.Receita + r
	return p
}

func LucroProduto (p Produto, l float64) Produto{
	p.Lucro = p.Lucro + l
	return p
}

func ValorVenda(p Produto) float64 {
	return p.VCusto + p.VCusto * (float64(p.Percentual)/100.0);
}

func BuscaProduto(cod int, p []Produto) int {
	var index int
	for i:= range p {
		if cod == p[i].Cod {
			index = i
			break
		}
	}
	return index
}

